/*
 * Docs Dispatcher API - API document(s) generation
 * Docs.io API enables you to generate files (currently DOCx, XLSx, PPTx, PDF, HTML, JPG/PNG/SVG) from a template and JSON data. You can just download resulting file, send email with generated attachments or compose services.
 *
 * The version of the OpenAPI document: 3.1.1
 * Contact: tech@docs-dispatcher.io
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package io.docs_dispatcher.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;

import java.io.IOException;
import com.google.gson.TypeAdapter;
import com.google.gson.JsonElement;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * Gets or Sets MediaFormat
 */
@JsonAdapter(MediaFormat.Adapter.class)
public enum MediaFormat {
  
  HTML("HTML"),
  
  WORD("WORD"),
  
  EXCEL("EXCEL"),
  
  POWERPOINT("POWERPOINT"),
  
  SVG("SVG"),
  
  PNG("PNG"),
  
  JPEG("JPEG"),
  
  PDF("PDF"),
  
  TEXT_PLAIN("TEXT_PLAIN"),
  
  MULTIPART_ALTERNATIVE("MULTIPART_ALTERNATIVE");

  private String value;

  MediaFormat(String value) {
    this.value = value;
  }

  public String getValue() {
    return value;
  }

  @Override
  public String toString() {
    return String.valueOf(value);
  }

  public static MediaFormat fromValue(String value) {
    for (MediaFormat b : MediaFormat.values()) {
      if (b.value.equals(value)) {
        return b;
      }
    }
    throw new IllegalArgumentException("Unexpected value '" + value + "'");
  }

  public static class Adapter extends TypeAdapter<MediaFormat> {
    @Override
    public void write(final JsonWriter jsonWriter, final MediaFormat enumeration) throws IOException {
      jsonWriter.value(enumeration.getValue());
    }

    @Override
    public MediaFormat read(final JsonReader jsonReader) throws IOException {
      String value = jsonReader.nextString();
      return MediaFormat.fromValue(value);
    }
  }

  public static void validateJsonElement(JsonElement jsonElement) throws IOException {
    String value = jsonElement.getAsString();
    MediaFormat.fromValue(value);
  }
}

